2013-08-04 13:27:31 +00:00
#!/bin/bash
2013-06-18 11:34:14 +00:00
2013-07-20 11:43:11 +00:00
###### Osync - Rsync based two way sync engine with fault tolerance
2013-07-16 11:55:15 +00:00
###### (L) 2013 by Orsiris "Ozy" de Jong (www.netpower.fr)
2013-11-02 20:57:15 +00:00
OSYNC_VERSION = 0.99RC2
2013-11-02 22:33:54 +00:00
OSYNC_BUILD = 0211201302
2013-06-18 11:34:14 +00:00
2013-08-18 11:15:40 +00:00
DEBUG = no
2013-06-18 11:34:14 +00:00
SCRIPT_PID = $$
LOCAL_USER = $( whoami)
LOCAL_HOST = $( hostname)
2013-07-15 22:10:23 +00:00
## Default log file until config file is loaded
2013-11-02 20:57:15 +00:00
if [ -w /var/log ]
2013-10-10 18:17:40 +00:00
then
LOG_FILE = /var/log/osync.log
else
LOG_FILE = ./osync.log
fi
## Default directory where to store run files
2013-11-02 20:57:15 +00:00
if [ -w /dev/shm ]
2013-10-10 18:17:40 +00:00
then
RUN_DIR = /dev/shm
2013-11-02 20:57:15 +00:00
elif [ -w /tmp ]
2013-10-10 18:17:40 +00:00
then
RUN_DIR = /tmp
2013-11-02 20:57:15 +00:00
elif [ -w /var/tmp ]
2013-10-10 18:17:40 +00:00
then
RUN_DIR = /var/tmp
else
RUN_DIR = .
fi
2013-07-15 22:10:23 +00:00
2013-07-16 11:55:15 +00:00
## Working directory. Will keep current file states, backups and soft deleted files.
2013-07-15 22:10:23 +00:00
OSYNC_DIR = ".osync_workdir"
## Log a state message every $KEEP_LOGGING seconds. Should not be equal to soft or hard execution time so your log won't be unnecessary big.
KEEP_LOGGING = 1801
2013-06-18 11:34:14 +00:00
2013-08-03 21:06:09 +00:00
## Correct output of sort command (language agnostic sorting)
export LC_ALL = C
2013-06-18 11:34:14 +00:00
function Log
{
2013-07-16 21:06:26 +00:00
echo -e " TIME: $SECONDS - $1 " >> " $LOG_FILE "
2013-07-15 22:10:23 +00:00
if [ $silent -eq 0 ]
then
2013-07-16 21:06:26 +00:00
echo -e " TIME: $SECONDS - $1 "
2013-07-15 22:10:23 +00:00
fi
2013-06-18 11:34:14 +00:00
}
function LogError
{
2013-07-15 22:10:23 +00:00
Log " $1 "
error_alert = 1
2013-06-18 11:34:14 +00:00
}
2013-07-21 19:40:55 +00:00
function LogDebug
{
if [ " $DEBUG " = = "yes" ]
then
Log " $1 "
fi
}
2013-07-22 19:14:57 +00:00
function TrapError {
2013-07-15 22:10:23 +00:00
local JOB = " $0 "
local LINE = " $1 "
local CODE = " ${ 2 :- 1 } "
if [ $silent -eq 0 ]
then
2013-07-24 08:38:42 +00:00
echo -e " /!\ ERROR in ${ JOB } : Near line ${ LINE } , exit code ${ CODE } "
2013-07-15 22:10:23 +00:00
fi
2013-06-18 11:34:14 +00:00
}
2013-07-16 21:06:26 +00:00
function TrapStop
{
if [ $soft_stop -eq 0 ]
then
2013-07-17 09:34:05 +00:00
LogError " /!\ WARNING: Manual exit of osync is really not recommended. Sync will be in inconsistent state."
LogError " /!\ WARNING: If you are sure, please hit CTRL+C another time to quit."
2013-07-16 21:06:26 +00:00
soft_stop = 1
2013-07-17 09:34:05 +00:00
return 1
2013-07-16 21:06:26 +00:00
fi
2013-07-17 09:34:05 +00:00
if [ $soft_stop -eq 1 ]
2013-07-16 21:06:26 +00:00
then
2013-07-22 19:14:57 +00:00
LogError " /!\ WARNING: CTRL+C hit twice. Quitting osync. Please wait..."
soft_stop = 2
exit 1
2013-07-16 21:06:26 +00:00
fi
}
2013-07-17 09:34:05 +00:00
function TrapQuit
{
2013-09-03 19:22:38 +00:00
## Stopping all running child processes
2013-10-10 18:17:40 +00:00
if type -p pkill > /dev/null 2>& 1
then
pkill -TERM -P $$
2013-11-02 20:57:15 +00:00
elif [ " $LOCAL_OS " = = "msys" ] || [ " $OSTYPE " = = "msys" ]
2013-10-10 18:17:40 +00:00
then
## This is not really a clean way to get child process pids, especially the tail -n +2 which resolves a strange char apparition in msys bash
for pid in $( ps -a | awk '{$1=$1}$1' | awk '{print $1" "$2}' | grep " $$ $" | awk '{print $1}' | tail -n +2)
do
kill -9 $pid > /dev/null 2>& 1
done
else
for pid in $( ps -a --Group $$ )
do
kill -9 $pid
done
fi
2013-09-03 19:22:38 +00:00
2013-07-17 09:34:05 +00:00
if [ $error_alert -ne 0 ]
then
SendAlert
2013-07-19 23:00:58 +00:00
UnlockDirectories
2013-07-22 19:14:57 +00:00
CleanUp
2013-07-21 19:40:55 +00:00
LogError "Osync finished with errros."
2013-07-17 09:34:05 +00:00
exit 1
else
2013-07-19 23:00:58 +00:00
UnlockDirectories
2013-07-22 19:14:57 +00:00
CleanUp
2013-07-21 19:40:55 +00:00
Log "Osync finished."
2013-07-17 09:34:05 +00:00
exit 0
fi
}
2013-07-16 21:06:26 +00:00
2013-06-18 11:34:14 +00:00
function Spinner
{
2013-07-15 22:10:23 +00:00
if [ $silent -eq 1 ]
then
return 1
fi
2013-06-18 11:34:14 +00:00
2013-07-15 22:10:23 +00:00
case $toggle
in
1)
echo -n $1 " \ "
echo -ne "\r"
toggle = "2"
; ;
2)
echo -n $1 " | "
echo -ne "\r"
toggle = "3"
; ;
3)
echo -n $1 " / "
echo -ne "\r"
toggle = "4"
; ;
*)
echo -n $1 " - "
echo -ne "\r"
toggle = "1"
; ;
esac
2013-06-18 11:34:14 +00:00
}
2013-07-19 16:15:25 +00:00
function EscapeSpaces
{
2013-07-24 08:38:42 +00:00
echo $( echo " $1 " | sed 's/ /\\ /g' )
2013-07-19 16:15:25 +00:00
}
2013-07-15 22:10:23 +00:00
function CleanUp
2013-06-18 11:34:14 +00:00
{
2013-07-17 09:34:05 +00:00
if [ " $DEBUG " != "yes" ]
then
2013-10-10 18:17:40 +00:00
rm -f $RUN_DIR /osync_config_$SCRIPT_PID
2013-10-11 19:35:20 +00:00
rm -f $RUN_DIR /osync_remote_os_$SCRIPT_PID
2013-10-10 18:17:40 +00:00
rm -f $RUN_DIR /osync_run_local_$SCRIPT_PID
rm -f $RUN_DIR /osync_run_remote_$SCRIPT_PID
rm -f $RUN_DIR /osync_master-tree-current_$SCRIPT_PID
rm -f $RUN_DIR /osync_slave-tree-current_$SCRIPT_PID
rm -f $RUN_DIR /osync_master-tree-after_$SCRIPT_PID
rm -f $RUN_DIR /osync_slave-tree-after_$SCRIPT_PID
rm -f $RUN_DIR /osync_update_master_replica_$SCRIPT_PID
rm -f $RUN_DIR /osync_update_slave_replica_$SCRIPT_PID
rm -f $RUN_DIR /osync_deletion_on_master_$SCRIPT_PID
rm -f $RUN_DIR /osync_deletion_on_slave_$SCRIPT_PID
rm -f $RUN_DIR /osync_remote_slave_lock_$SCRIPT_PID
rm -f $RUN_DIR /osync_slave_space_$SCRIPT_PID
2013-07-17 09:34:05 +00:00
fi
2013-06-18 11:34:14 +00:00
}
function SendAlert
{
2013-11-03 19:29:17 +00:00
if [ " $quick_sync " = = "2" ]
then
Log "Current task is a quicksync task. Will not send any alert."
return 0
fi
2013-07-15 22:10:23 +00:00
cat " $LOG_FILE " | gzip -9 > /tmp/osync_lastlog.gz
2013-06-18 11:34:14 +00:00
if type -p mutt > /dev/null 2>& 1
then
2013-10-10 18:17:40 +00:00
echo $MAIL_ALERT_MSG | $( type -p mutt) -x -s " Sync alert for $SYNC_ID " $DESTINATION_MAILS -a /tmp/osync_lastlog.gz
2013-06-18 11:34:14 +00:00
if [ $? != 0 ]
then
2013-10-10 18:17:40 +00:00
Log " WARNING: Cannot send alert email via $( type -p mutt) !!! "
2013-07-15 22:10:23 +00:00
else
Log "Sent alert mail using mutt."
2013-06-18 11:34:14 +00:00
fi
elif type -p mail > /dev/null 2>& 1
2013-07-15 22:10:23 +00:00
then
2013-10-10 18:17:40 +00:00
echo $MAIL_ALERT_MSG | $( type -p mail) -a /tmp/osync_lastlog.gz -s " Sync alert for $SYNC_ID " $DESTINATION_MAILS
2013-06-18 11:34:14 +00:00
if [ $? != 0 ]
then
2013-10-10 18:17:40 +00:00
Log " WARNING: Cannot send alert email via $( type -p mail) with attachments !!! "
echo $MAIL_ALERT_MSG | $( type -p mail) -s " Sync alert for $SYNC_ID " $DESTINATION_MAILS
2013-07-15 22:10:23 +00:00
if [ $? != 0 ]
then
2013-10-10 18:17:40 +00:00
Log " WARNING: Cannot send alert email via $( type -p mail) without attachments !!! "
2013-07-15 22:10:23 +00:00
else
Log "Sent alert mail using mail command without attachment."
fi
else
Log "Sent alert mail using mail command."
2013-06-18 11:34:14 +00:00
fi
2013-10-10 18:17:40 +00:00
elif type -p sendemail > /dev/null 2>& 1
then
$( type -p sendemail) -f $SENDER_MAIL -t $DESTINATION_MAILS -u " Backup alert for $BACKUP_ID " -m " $MAIL_ALERT_MSG " -s $SMTP_SERVER -o username $SMTP_USER -p password $SMTP_PASSWORD > /dev/null 2>& 1
if [ $? != 0 ]
then
Log " WARNING: Cannot send alert email via $( type -p sendemail) !!! "
else
Log "Sent alert mail using sendemail command without attachment."
fi
2013-06-18 11:34:14 +00:00
else
2013-07-15 22:10:23 +00:00
Log "WARNING: Cannot send alert email (no mutt / mail present) !!!"
return 1
fi
2013-06-18 11:34:14 +00:00
}
function LoadConfigFile
{
2013-07-15 22:10:23 +00:00
if [ ! -f " $1 " ]
then
LogError " Cannot load configuration file [ $1 ]. Sync cannot start. "
2013-11-03 19:29:17 +00:00
exit 1
2013-08-04 07:47:47 +00:00
elif [ [ " $1 " != *".conf" ] ]
2013-07-15 22:10:23 +00:00
then
LogError " Wrong configuration file supplied [ $1 ]. Sync cannot start. "
2013-11-03 19:29:17 +00:00
exit 1
2013-07-15 22:10:23 +00:00
else
2013-10-10 18:17:40 +00:00
egrep '^#|^[^ ]*=[^;&]*' " $1 " > " $RUN_DIR /osync_config_ $SCRIPT_PID "
source " $RUN_DIR /osync_config_ $SCRIPT_PID "
2013-07-15 22:10:23 +00:00
fi
}
2013-06-18 11:34:14 +00:00
function CheckEnvironment
{
2013-07-15 22:10:23 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
2013-06-18 11:34:14 +00:00
then
2013-07-15 22:10:23 +00:00
if ! type -p ssh > /dev/null 2>& 1
then
LogError "ssh not present. Cannot start sync."
return 1
fi
fi
if ! type -p rsync > /dev/null 2>& 1
then
LogError "rsync not present. Sync cannot start."
return 1
fi
2013-06-18 11:34:14 +00:00
}
2013-10-11 19:35:20 +00:00
function GetOperatingSystem
{
LOCAL_OS_VAR = $( uname -spio)
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-11-02 20:57:15 +00:00
eval " $SSH_CMD \"uname -spio\" > $RUN_DIR /osync_remote_os_ $SCRIPT_PID 2>&1 "
2013-11-03 19:29:17 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 120 240
retval = $?
if [ $retval != 0 ]
2013-11-02 20:57:15 +00:00
then
LogError "Cannot Get remote OS type."
else
REMOTE_OS_VAR = $( cat $RUN_DIR /osync_remote_os_$SCRIPT_PID )
fi
2013-10-11 19:35:20 +00:00
fi
case $LOCAL_OS_VAR in
"Linux" *)
LOCAL_OS = "Linux"
; ;
"FreeBSD" *)
LOCAL_OS = "FreeBSD"
; ;
"MINGW32" *)
LOCAL_OS = "msys"
; ;
*)
LogError " Running on >> $LOCAL_OS_VAR << not supported. Please report to the author. "
exit 1
; ;
esac
case $REMOTE_OS_VAR in
"Linux" *)
REMOTE_OS = "Linux"
; ;
"FreeBSD" *)
REMOTE_OS = "FreeBSD"
; ;
"MINGW32" *)
REMOTE_OS = "msys"
; ;
"" )
; ;
*)
LogError " Running on remote >> $REMOTE_OS_VAR << not supported. Please report to the author. "
exit 1
esac
2013-11-02 20:57:15 +00:00
if [ " $DEBUG " = = "yes" ]
then
Log " Local OS: [ $LOCAL_OS_VAR ]. "
if [ " $REMOTE_BACKUP " = = "yes" ]
then
Log " Remote OS: [ $REMOTE_OS_VAR ]. "
fi
fi
2013-10-11 19:35:20 +00:00
}
2013-07-18 11:39:52 +00:00
# Waits for pid $1 to complete. Will log an alert if $2 seconds passed since current task execution unless $2 equals 0.
# Will stop task and log alert if $3 seconds passed since current task execution unless $3 equals 0.
function WaitForTaskCompletion
2013-06-18 11:34:14 +00:00
{
soft_alert = 0
SECONDS_BEGIN = $SECONDS
2013-10-11 19:35:20 +00:00
if [ " $LOCAL_OS " = = "msys" ]
2013-10-10 18:17:40 +00:00
then
PROCESS_TEST = " ps -a | awk '{\$1=\$1}\$1' | awk '{print \$1}' | grep $1 "
else
PROCESS_TEST = " ps -p $1 "
fi
while eval $PROCESS_TEST > /dev/null
2013-06-18 11:34:14 +00:00
do
Spinner
sleep 1
EXEC_TIME = $(( $SECONDS - $SECONDS_BEGIN ))
if [ $(( $EXEC_TIME % $KEEP_LOGGING )) -eq 0 ]
then
Log "Current task still running."
fi
if [ $EXEC_TIME -gt $2 ]
then
if [ $soft_alert -eq 0 ] && [ $2 != 0 ]
then
LogError "Max soft execution time exceeded for task."
soft_alert = 1
fi
if [ $EXEC_TIME -gt $3 ] && [ $3 != 0 ]
then
LogError "Max hard execution time exceeded for task. Stopping task execution."
2013-07-18 20:41:31 +00:00
kill -s SIGTERM $1
2013-07-18 11:39:52 +00:00
if [ $? = = 0 ]
then
LogError "Task stopped succesfully"
else
2013-07-18 20:41:31 +00:00
LogError "Sending SIGTERM to proces failed. Trying the hard way."
kill -9 $1
if [ $? != 0 ]
then
LogError "Could not stop task."
fi
2013-07-18 11:39:52 +00:00
fi
2013-06-18 11:34:14 +00:00
return 1
fi
2013-07-20 11:43:11 +00:00
fi
2013-06-18 11:34:14 +00:00
done
2013-07-21 19:40:55 +00:00
wait $child_pid
return $?
2013-06-18 11:34:14 +00:00
}
2013-07-18 11:39:52 +00:00
# Waits for pid $1 to complete. Will log an alert if $2 seconds passed since script start unless $2 equals 0.
# Will stop task and log alert if $3 seconds passed since script start unless $3 equals 0.
function WaitForCompletion
{
soft_alert = 0
2013-10-11 19:35:20 +00:00
if [ " $LOCAL_OS " = = "msys" ]
2013-10-10 18:17:40 +00:00
then
PROCESS_TEST = " ps -a | awk '{\$1=\$1}\$1' | awk '{print \$1}' | grep $1 "
else
PROCESS_TEST = " ps -p $1 "
fi
while eval $PROCESS_TEST > /dev/null
2013-07-18 11:39:52 +00:00
do
Spinner
sleep 1
if [ $(( $SECONDS % $KEEP_LOGGING )) -eq 0 ]
then
Log "Current task still running."
fi
if [ $SECONDS -gt $2 ]
then
if [ $soft_alert -eq 0 ] && [ $2 != 0 ]
then
LogError "Max soft execution time exceeded for script."
soft_alert = 1
fi
if [ $SECONDS -gt $3 ] && [ $3 != 0 ]
then
LogError "Max hard execution time exceeded for script. Stopping current task execution."
2013-07-21 19:40:55 +00:00
kill -s SIGTERM $1
2013-07-18 11:39:52 +00:00
if [ $? = = 0 ]
then
LogError "Task stopped succesfully"
else
2013-07-18 20:41:31 +00:00
LogError "Sending SIGTERM to proces failed. Trying the hard way."
kill -9 $1
if [ $? != 0 ]
then
LogError "Could not stop task."
fi
2013-07-18 11:39:52 +00:00
fi
return 1
fi
fi
done
2013-07-21 19:40:55 +00:00
wait $child_pid
return $?
2013-07-18 11:39:52 +00:00
}
2013-06-18 11:34:14 +00:00
## Runs local command $1 and waits for completition in $2 seconds
function RunLocalCommand
{
2013-09-03 19:22:38 +00:00
if [ $dryrun -ne 0 ]
then
Log " Dryrun: Local command [ $1 ] not run. "
return 1
fi
2013-11-02 20:57:15 +00:00
Log " Running command [ $1 ] on local host. "
eval " $1 " > $RUN_DIR /osync_run_local_$SCRIPT_PID 2>& 1 &
2013-07-15 22:10:23 +00:00
child_pid = $!
2013-07-18 11:39:52 +00:00
WaitForTaskCompletion $child_pid 0 $2
2013-07-15 22:10:23 +00:00
retval = $?
if [ $retval -eq 0 ]
then
2013-11-02 20:57:15 +00:00
Log "Command succeded."
2013-07-15 22:10:23 +00:00
else
2013-11-02 20:57:15 +00:00
LogError "Command failed."
2013-07-15 22:10:23 +00:00
fi
2013-06-18 11:34:14 +00:00
2013-07-20 11:43:11 +00:00
if [ $verbose -eq 1 ]
then
2013-10-10 18:17:40 +00:00
Log " Command output:\n $( cat $RUN_DIR /osync_run_local_$SCRIPT_PID ) "
2013-07-20 11:43:11 +00:00
fi
2013-09-11 14:23:57 +00:00
2013-11-02 20:57:15 +00:00
if [ " $STOP_ON_CMD_ERROR " = = "yes" ] && [ $retval -ne 0 ]
2013-09-11 14:23:57 +00:00
then
exit 1
fi
2013-06-18 11:34:14 +00:00
}
## Runs remote command $1 and waits for completition in $2 seconds
function RunRemoteCommand
{
2013-07-15 22:10:23 +00:00
CheckConnectivity3rdPartyHosts
2013-08-24 17:51:39 +00:00
CheckConnectivityRemoteHost
2013-09-03 19:22:38 +00:00
if [ $dryrun -ne 0 ]
then
Log " Dryrun: Local command [ $1 ] not run. "
return 1
fi
2013-11-02 20:57:15 +00:00
Log " Running command [ $1 ] on remote host. "
2013-10-10 18:17:40 +00:00
eval " $SSH_CMD \" $1 \" > $RUN_DIR /osync_run_remote_ $SCRIPT_PID 2>&1 & "
2013-08-24 17:51:39 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 0 $2
retval = $?
if [ $retval -eq 0 ]
2013-07-15 22:10:23 +00:00
then
2013-11-02 20:57:15 +00:00
Log "Command succeded."
2013-08-24 17:51:39 +00:00
else
2013-11-02 20:57:15 +00:00
LogError "Command failed."
2013-08-24 17:51:39 +00:00
fi
2013-07-15 22:10:23 +00:00
2013-10-10 18:17:40 +00:00
if [ -f $RUN_DIR /osync_run_remote_$SCRIPT_PID ] && [ $verbose -eq 1 ]
2013-08-24 17:51:39 +00:00
then
2013-10-10 18:17:40 +00:00
Log " Command output:\n $( cat $RUN_DIR /osync_run_remote_$SCRIPT_PID ) "
2013-07-15 22:10:23 +00:00
fi
2013-09-11 14:23:57 +00:00
2013-11-02 20:57:15 +00:00
if [ " $STOP_ON_CMD_ERROR " = = "yes" ] && [ $retval -ne 0 ]
2013-09-11 14:23:57 +00:00
then
exit 1
fi
2013-06-18 11:34:14 +00:00
}
function RunBeforeHook
{
2013-07-15 22:10:23 +00:00
if [ " $LOCAL_RUN_BEFORE_CMD " != "" ]
then
RunLocalCommand " $LOCAL_RUN_BEFORE_CMD " $MAX_EXEC_TIME_PER_CMD_BEFORE
fi
2013-06-18 11:34:14 +00:00
2013-07-15 22:10:23 +00:00
if [ " $REMOTE_RUN_BEFORE_CMD " != "" ]
then
RunRemoteCommand " $REMOTE_RUN_BEFORE_CMD " $MAX_EXEC_TIME_PER_CMD_BEFORE
fi
2013-06-18 11:34:14 +00:00
}
function RunAfterHook
{
if [ " $LOCAL_RUN_AFTER_CMD " != "" ]
then
2013-07-15 22:10:23 +00:00
RunLocalCommand " $LOCAL_RUN_AFTER_CMD " $MAX_EXEC_TIME_PER_CMD_AFTER
2013-06-18 11:34:14 +00:00
fi
2013-07-15 22:10:23 +00:00
if [ " $REMOTE_RUN_AFTER_CMD " != "" ]
then
RunRemoteCommand " $REMOTE_RUN_AFTER_CMD " $MAX_EXEC_TIME_PER_CMD_AFTER
fi
2013-06-18 11:34:14 +00:00
}
2013-07-15 22:10:23 +00:00
function CheckConnectivityRemoteHost
{
if [ " $REMOTE_HOST_PING " != "no" ] && [ " $REMOTE_SYNC " != "no" ]
then
2013-10-11 19:35:20 +00:00
if [ " $LOCAL_OS " = = "msys" ]
2013-10-10 18:17:40 +00:00
then
2013-10-11 20:27:33 +00:00
ping -n 2 $REMOTE_HOST > /dev/null 2>& 1
2013-10-10 18:17:40 +00:00
else
2013-10-11 20:27:33 +00:00
ping -c 2 $REMOTE_HOST > /dev/null 2>& 1
2013-10-10 18:17:40 +00:00
fi
2013-07-15 22:10:23 +00:00
if [ $? != 0 ]
then
LogError " Cannot ping $REMOTE_HOST "
2013-08-24 17:51:39 +00:00
exit 1
fi
fi
2013-07-15 22:10:23 +00:00
}
function CheckConnectivity3rdPartyHosts
{
if [ " $REMOTE_3RD_PARTY_HOSTS " != "" ]
then
remote_3rd_party_success = 0
2013-09-13 11:30:39 +00:00
OLD_IFS = $IFS
IFS = $' \t\n'
2013-08-24 17:51:39 +00:00
for i in $REMOTE_3RD_PARTY_HOSTS
2013-07-15 22:10:23 +00:00
do
2013-10-11 19:35:20 +00:00
if [ " $LOCAL_OS " = = "msys" ]
2013-10-10 18:17:40 +00:00
then
2013-10-11 20:27:33 +00:00
ping -n 2 $i > /dev/null 2>& 1
2013-10-10 18:17:40 +00:00
else
2013-10-11 20:27:33 +00:00
ping -c 2 $i > /dev/null 2>& 1
2013-10-10 18:17:40 +00:00
fi
2013-07-15 22:10:23 +00:00
if [ $? != 0 ]
then
2013-08-25 10:37:37 +00:00
Log " Cannot ping 3rd party host $i "
2013-07-15 22:10:23 +00:00
else
remote_3rd_party_success = 1
fi
done
2013-09-13 11:30:39 +00:00
IFS = $OLD_IFS
2013-07-15 22:10:23 +00:00
if [ $remote_3rd_party_success -ne 1 ]
then
LogError "No remote 3rd party host responded to ping. No internet ?"
2013-08-24 17:51:39 +00:00
exit 1
fi
2013-07-15 22:10:23 +00:00
fi
}
2013-07-20 11:43:11 +00:00
function CreateOsyncDirs
2013-07-15 22:10:23 +00:00
{
2013-07-22 19:14:57 +00:00
if ! [ -d " $MASTER_STATE_DIR " ]
2013-06-18 11:34:14 +00:00
then
2013-10-11 20:27:33 +00:00
mkdir -p " $MASTER_STATE_DIR "
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
then
LogError " Cannot create master replica state dir [ $MASTER_STATE_DIR ]. "
exit 1
fi
2013-06-18 11:34:14 +00:00
fi
2013-07-20 11:43:11 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-10-11 20:27:33 +00:00
eval " $SSH_CMD \"if ! [ -d \\\" $SLAVE_STATE_DIR \\\" ]; then $COMMAND_SUDO mkdir -p \\\" $SLAVE_STATE_DIR \\\"; fi\" " &
2013-07-24 19:03:58 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 0 1800
2013-07-20 11:43:11 +00:00
else
2013-10-11 20:27:33 +00:00
if ! [ -d " $SLAVE_STATE_DIR " ] ; then mkdir -p " $SLAVE_STATE_DIR " ; fi
2013-07-21 19:40:55 +00:00
fi
if [ $? != 0 ]
then
LogError " Cannot create slave replica state dir [ $SLAVE_STATE_DIR ]. "
exit 1
2013-07-20 11:43:11 +00:00
fi
2013-06-18 11:34:14 +00:00
}
2013-07-15 22:10:23 +00:00
function CheckMasterSlaveDirs
2013-06-18 11:34:14 +00:00
{
2013-07-22 19:14:57 +00:00
if ! [ -d " $MASTER_SYNC_DIR " ]
2013-06-18 11:34:14 +00:00
then
2013-07-21 19:40:55 +00:00
if [ " $CREATE_DIRS " = = "yes" ]
then
2013-10-11 20:27:33 +00:00
mkdir -p " $MASTER_SYNC_DIR "
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
then
LogError " Cannot create master directory [ $MASTER_SYNC_DIR ]. "
exit 1
fi
else
LogError " Master directory [ $MASTER_SYNC_DIR ] does not exist. "
exit 1
fi
2013-06-18 11:34:14 +00:00
fi
2013-07-20 11:43:11 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
2013-06-18 11:34:14 +00:00
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-07-21 19:40:55 +00:00
if [ " $CREATE_DIRS " = = "yes" ]
2013-07-20 11:43:11 +00:00
then
2013-10-11 20:27:33 +00:00
eval " $SSH_CMD \"if ! [ -d \\\" $SLAVE_SYNC_DIR \\\" ]; then $COMMAND_SUDO mkdir -p \\\" $SLAVE_SYNC_DIR \\\"; fi " \" &
2013-07-24 19:03:58 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 0 1800
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
then
LogError " Cannot create slave directory [ $SLAVE_SYNC_DIR ]. "
exit 1
fi
else
2013-07-24 19:03:58 +00:00
eval " $SSH_CMD \"if ! [ -d \\\" $SLAVE_SYNC_DIR \\\" ]; then exit 1; fi " \" &
child_pid = $!
WaitForTaskCompletion $child_pid 0 1800
res = $?
if [ $res != 0 ]
2013-07-21 19:40:55 +00:00
then
LogError " Slave directory [ $SLAVE_SYNC_DIR ] does not exist. "
exit 1
fi
2013-07-20 11:43:11 +00:00
fi
else
2013-07-22 19:14:57 +00:00
if [ ! -d " $SLAVE_SYNC_DIR " ]
2013-07-20 11:43:11 +00:00
then
2013-07-21 19:40:55 +00:00
if [ " $CREATE_DIRS " = = "yes" ]
then
2013-10-11 20:27:33 +00:00
mkdir -p " $SLAVE_SYNC_DIR "
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
then
LogError " Cannot create slave directory [ $SLAVE_SYNC_DIR ]. "
exit 1
else
Log " Created slave directory [ $SLAVE_SYNC_DIR ]. "
fi
else
LogError " Slave directory [ $SLAVE_SYNC_DIR ] does not exist. "
exit 1
fi
2013-07-20 11:43:11 +00:00
fi
2013-06-18 11:34:14 +00:00
fi
}
2013-07-22 19:14:57 +00:00
function CheckMinimumSpace
{
Log "Checking minimum disk space on master and slave."
MASTER_SPACE = $( df -P " $MASTER_SYNC_DIR " | tail -1 | awk '{print $4}' )
if [ $MASTER_SPACE -lt $MINIMUM_SPACE ]
then
LogError " There is not enough free space on master [ $MASTER_SPACE KB]. "
fi
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-10-10 18:17:40 +00:00
eval " $SSH_CMD \" $COMMAND_SUDO df -P \\\" $SLAVE_SYNC_DIR \\\"\" " > $RUN_DIR /osync_slave_space_$SCRIPT_PID &
2013-07-24 19:03:58 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 0 1800
2013-10-10 18:17:40 +00:00
SLAVE_SPACE = $( cat $RUN_DIR /osync_slave_space_$SCRIPT_PID | tail -1 | awk '{print $4}' )
2013-07-22 19:14:57 +00:00
else
SLAVE_SPACE = $( df -P " $SLAVE_SYNC_DIR " | tail -1 | awk '{print $4}' )
fi
if [ $SLAVE_SPACE -lt $MINIMUM_SPACE ]
then
LogError " There is not enough free space on slave [ $SLAVE_SPACE KB]. "
fi
}
2013-07-19 16:15:25 +00:00
function RsyncExcludePattern
{
OLD_IFS = $IFS
IFS = $PATH_SEPARATOR_CHAR
for excludedir in $RSYNC_EXCLUDE_PATTERN
do
if [ " $RSYNC_EXCLUDE " = = "" ]
then
2013-07-23 18:57:38 +00:00
RSYNC_EXCLUDE = " --exclude=\" $excludedir \" "
2013-07-19 16:15:25 +00:00
else
2013-07-23 18:57:38 +00:00
RSYNC_EXCLUDE = " $RSYNC_EXCLUDE --exclude=\" $excludedir \" "
2013-07-19 16:15:25 +00:00
fi
done
IFS = $OLD_IFS
}
2013-07-21 19:40:55 +00:00
function WriteLockFiles
{
2013-07-22 19:14:57 +00:00
echo $SCRIPT_PID > " $MASTER_STATE_DIR /lock "
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
then
LogError "Could not set lock on master replica."
exit 1
else
Log "Locked master replica."
fi
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-07-23 18:57:38 +00:00
eval " $SSH_CMD \" $COMMAND_SUDO echo $SCRIPT_PID @ $SYNC_ID > \\\" $SLAVE_STATE_DIR /lock\\\"\" " &
2013-07-24 19:03:58 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 0 1800
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
then
LogError "Could not set lock on remote slave replica."
exit 1
else
Log "Locked remote slave replica."
fi
else
2013-07-22 19:14:57 +00:00
echo " $SCRIPT_PID @ $SYNC_ID " > " $SLAVE_STATE_DIR /lock "
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
then
LogError "Couuld not set lock on local slave replica."
exit 1
else
Log "Locked local slave replica."
fi
fi
}
2013-07-19 23:00:58 +00:00
function LockDirectories
2013-07-15 22:10:23 +00:00
{
2013-07-21 19:40:55 +00:00
if [ $force_unlock -eq 1 ]
2013-07-19 23:00:58 +00:00
then
2013-07-21 19:40:55 +00:00
WriteLockFiles
if [ $? != 0 ]
2013-07-19 23:00:58 +00:00
then
exit 1
fi
2013-07-21 19:40:55 +00:00
fi
Log "Checking for replica locks."
2013-07-22 19:14:57 +00:00
if [ -f " $MASTER_STATE_DIR /lock " ]
2013-07-19 23:00:58 +00:00
then
2013-07-21 19:40:55 +00:00
master_lock_pid = $( cat $MASTER_STATE_DIR /lock)
2013-08-04 13:27:31 +00:00
LogDebug " Master lock pid present: $master_lock_pid "
ps -p$master_lock_pid > /dev/null 2>& 1
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
2013-07-19 23:00:58 +00:00
then
2013-07-21 19:40:55 +00:00
Log " There is a dead osync lock on master. Instance $master_lock_pid no longer running. Resuming. "
2013-07-19 23:00:58 +00:00
else
2013-07-21 19:40:55 +00:00
LogError " There is already a local instance of osync that locks master replica. Cannot start. If your are sure this is an error, plaese kill instance $master_lock_pid of osync. "
exit 1
2013-07-19 23:00:58 +00:00
fi
2013-07-21 19:40:55 +00:00
fi
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-10-10 18:17:40 +00:00
eval " $SSH_CMD \"if [ -f \\\" $SLAVE_STATE_DIR /lock\\\" ]; then cat \\\" $SLAVE_STATE_DIR /lock\\\"; fi\" > $RUN_DIR /osync_remote_slave_lock_ $SCRIPT_PID " &
2013-07-24 19:03:58 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 0 1800
2013-11-02 20:57:15 +00:00
if [ -f $RUN_DIR /osync_remote_slave_lock_$SCRIPT_PID ]
2013-07-23 18:57:38 +00:00
then
2013-10-10 18:17:40 +00:00
slave_lock_pid = $( cat $RUN_DIR /osync_remote_slave_lock_$SCRIPT_PID | cut -d'@' -f1)
slave_lock_id = $( cat $RUN_DIR /osync_remote_slave_lock_$SCRIPT_PID | cut -d'@' -f2)
2013-07-23 18:57:38 +00:00
fi
2013-07-19 23:00:58 +00:00
else
2013-07-22 19:14:57 +00:00
if [ -f " $SLAVE_STATE_DIR /lock " ]
2013-07-19 23:00:58 +00:00
then
2013-07-22 19:14:57 +00:00
slave_lock_pid = $( cat " $SLAVE_STATE_DIR /lock " | cut -d'@' -f1)
slave_lock_id = $( cat " $SLAVE_STATE_DIR /lock " | cut -d'@' -f2)
2013-07-21 19:40:55 +00:00
fi
fi
if [ " $slave_lock_pid " != "" ] && [ " $slave_lock_id " != "" ]
then
LogDebug " Slave lock pid: $slave_lock_pid "
LogDebug " Slave lock id: $slave_lock_pid "
ps -p$slave_lock_pid > /dev/null
if [ $? != 0 ]
then
if [ " $slave_lock_id " = = " $SYNC_ID " ]
then
2013-07-22 09:34:58 +00:00
Log " There is a dead osync lock on slave replica that corresponds to this master sync-id. Instance $slave_lock_pid no longer running. Resuming. "
2013-07-21 19:40:55 +00:00
else
if [ " $FORCE_STRANGER_LOCK_RESUME " = = "yes" ]
then
2013-07-22 09:34:58 +00:00
LogError "WARNING: There is a dead osync lock on slave replica that does not correspond to this master sync-id. Forcing resume."
2013-07-21 19:40:55 +00:00
else
2013-07-22 09:34:58 +00:00
LogError "There is a dead osync lock on slave replica that does not correspond to this master sync-id. Will not resume."
2013-07-21 19:40:55 +00:00
exit 1
fi
fi
2013-07-19 23:00:58 +00:00
else
2013-07-21 19:40:55 +00:00
LogError " There is already a local instance of osync that locks slave replica. Cannot start. If you are sure this is an error, please kill instance $slave_lock_pid of osync. "
2013-07-19 23:00:58 +00:00
exit 1
fi
fi
2013-07-21 19:40:55 +00:00
WriteLockFiles
2013-07-15 22:10:23 +00:00
}
2013-07-19 23:00:58 +00:00
function UnlockDirectories
2013-06-18 11:34:14 +00:00
{
2013-07-21 19:40:55 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
2013-07-19 23:00:58 +00:00
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-07-23 18:57:38 +00:00
eval " $SSH_CMD \"if [ -f \\\" $SLAVE_STATE_DIR /lock\\\" ]; then $COMMAND_SUDO rm \\\" $SLAVE_STATE_DIR /lock\\\"; fi\" " &
2013-07-24 19:03:58 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 0 1800
2013-07-21 19:40:55 +00:00
else
2013-07-22 19:14:57 +00:00
if [ -f " $SLAVE_STATE_DIR /lock " ] ; then rm " $SLAVE_STATE_DIR /lock " ; fi
2013-07-21 19:40:55 +00:00
fi
if [ $? != 0 ]
then
LogError "Could not unlock slave replica."
else
Log "Removed slave replica lock."
fi
2013-07-22 19:14:57 +00:00
if [ -f " $MASTER_STATE_DIR /lock " ]
2013-07-21 19:40:55 +00:00
then
2013-07-22 19:14:57 +00:00
rm " $MASTER_STATE_DIR /lock "
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
2013-07-19 23:00:58 +00:00
then
2013-07-21 19:40:55 +00:00
LogError "Could not unlock master replica."
2013-07-19 23:00:58 +00:00
else
2013-07-21 19:40:55 +00:00
Log "Removed master replica lock."
2013-07-19 23:00:58 +00:00
fi
fi
2013-07-15 22:10:23 +00:00
}
2013-07-18 20:41:31 +00:00
###### Sync core functions
2013-07-16 11:55:15 +00:00
2013-07-18 20:41:31 +00:00
function master_tree_current
2013-07-16 11:55:15 +00:00
{
Log "Creating master replica file list."
2013-08-03 21:06:09 +00:00
## Tree listing function: list | remove everything not file or directory | remove first 4 columns | remove empty leading spaces | remove "." dir (or return true if not exist)
2013-10-10 18:17:40 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" -rlptgoDE8 $RSYNC_ARGS --exclude \" $OSYNC_DIR \" $RSYNC_EXCLUDE --list-only \" $MASTER_SYNC_DIR /\" | grep \"^-\|^d\" | awk '{\$1=\$2=\$3=\$4=\"\" ;print}' | awk '{\$1=\$1 ;print}' | (grep -v \"^\. $\" || :) | sort > $RUN_DIR /osync_master-tree-current_ $SCRIPT_PID & "
2013-08-04 13:27:31 +00:00
if [ " $DEBUG " = = "yes" ]
then
Log " RSYNC_CMD: $rsync_cmd "
fi
eval $rsync_cmd
2013-07-16 21:06:26 +00:00
child_pid = $!
2013-07-18 11:39:52 +00:00
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME $HARD_MAX_EXEC_TIME
2013-10-10 18:17:40 +00:00
if [ $? = = 0 ] && [ -f $RUN_DIR /osync_master-tree-current_$SCRIPT_PID ]
2013-07-16 21:06:26 +00:00
then
2013-10-10 18:17:40 +00:00
mv $RUN_DIR /osync_master-tree-current_$SCRIPT_PID " $MASTER_STATE_DIR /master-tree-current "
2013-07-22 19:14:57 +00:00
echo "master-replica-tree.success" > " $MASTER_STATE_DIR /last-action "
2013-07-16 21:06:26 +00:00
else
LogError "Cannot create master file list."
2013-07-22 19:14:57 +00:00
echo "master-replica-tree.fail" > " $MASTER_STATE_DIR /last-action "
2013-07-19 23:00:58 +00:00
exit 1
2013-07-16 21:06:26 +00:00
fi
2013-07-18 20:41:31 +00:00
}
2013-07-16 21:06:26 +00:00
2013-07-18 20:41:31 +00:00
function slave_tree_current
{
2013-07-16 11:55:15 +00:00
Log "Creating slave replica file list."
2013-07-21 19:40:55 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-10-10 18:17:40 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" -rlptgoDE8 $RSYNC_ARGS --exclude \" $OSYNC_DIR \" $RSYNC_EXCLUDE -e \" $RSYNC_SSH_CMD \" --list-only $REMOTE_USER @ $REMOTE_HOST :\" $ESC_SLAVE_SYNC_DIR /\" | grep \"^-\|^d\" | awk '{\$1=\$2=\$3=\$4=\"\" ;print}' | awk '{\$1=\$1 ;print}' | (grep -v \"^\. $\" || :) | sort > $RUN_DIR /osync_slave-tree-current_ $SCRIPT_PID & "
2013-07-21 19:40:55 +00:00
else
2013-10-10 18:17:40 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" -rlptgoDE8 $RSYNC_ARGS --exclude \" $OSYNC_DIR \" $RSNYC_EXCLUDE --list-only \" $SLAVE_SYNC_DIR /\" | grep \"^-\|^d\" | awk '{\$1=\$2=\$3=\$4=\"\" ;print}' | awk '{\$1=\$1 ;print}' | (grep -v \"^\. $\" || :) | sort > $RUN_DIR /osync_slave-tree-current_ $SCRIPT_PID & "
2013-07-24 08:38:42 +00:00
fi
if [ " $DEBUG " = = "yes" ]
then
Log " RSYNC_CMD: $rsync_cmd "
2013-07-21 19:40:55 +00:00
fi
2013-07-24 08:38:42 +00:00
eval $rsync_cmd
2013-07-16 21:06:26 +00:00
child_pid = $!
2013-07-18 11:39:52 +00:00
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME $HARD_MAX_EXEC_TIME
2013-07-16 21:06:26 +00:00
retval = $?
2013-10-10 18:17:40 +00:00
if [ $retval = = 0 ] && [ -f $RUN_DIR /osync_slave-tree-current_$SCRIPT_PID ]
2013-07-16 21:06:26 +00:00
then
2013-10-10 18:17:40 +00:00
mv $RUN_DIR /osync_slave-tree-current_$SCRIPT_PID " $MASTER_STATE_DIR /slave-tree-current "
2013-07-22 19:14:57 +00:00
echo "slave-replica-tree.-success" > " $MASTER_STATE_DIR /last-action "
2013-07-16 21:06:26 +00:00
else
LogError "Cannot create slave file list."
2013-07-22 19:14:57 +00:00
echo "slave-replica-tree.fail" > " $MASTER_STATE_DIR /last-action "
2013-07-19 23:00:58 +00:00
exit 1
2013-07-16 21:06:26 +00:00
fi
2013-07-18 20:41:31 +00:00
}
2013-07-15 22:10:23 +00:00
2013-07-18 20:41:31 +00:00
function master_delete_list
{
2013-07-16 11:55:15 +00:00
Log "Creating master replica deleted file list."
2013-07-22 19:14:57 +00:00
if [ -f " $MASTER_STATE_DIR /master-tree-after " ]
2013-06-18 11:34:14 +00:00
then
2013-08-03 21:06:09 +00:00
comm -23 " $MASTER_STATE_DIR /master-tree-after " " $MASTER_STATE_DIR /master-tree-current " > " $MASTER_STATE_DIR /master-deleted-list "
2013-07-22 19:14:57 +00:00
echo "master-replica-deleted-list.success" > " $MASTER_STATE_DIR /last-action "
2013-06-18 11:34:14 +00:00
else
2013-07-22 19:14:57 +00:00
touch " $MASTER_STATE_DIR /master-deleted-list "
echo "master-replica-deleted-list.empty" > " $MASTER_STATE_DIR /last-action "
2013-06-18 11:34:14 +00:00
fi
2013-07-18 20:41:31 +00:00
}
2013-06-18 11:34:14 +00:00
2013-07-18 20:41:31 +00:00
function slave_delete_list
{
2013-07-16 11:55:15 +00:00
Log "Creating slave replica deleted file list."
2013-07-22 19:14:57 +00:00
if [ -f " $MASTER_STATE_DIR /slave-tree-after " ]
2013-06-18 11:34:14 +00:00
then
2013-08-03 21:06:09 +00:00
comm -23 " $MASTER_STATE_DIR /slave-tree-after " " $MASTER_STATE_DIR /slave-tree-current " > " $MASTER_STATE_DIR /slave-deleted-list "
2013-07-22 19:14:57 +00:00
echo "slave-replica-deleted-list.success" > " $MASTER_STATE_DIR /last-action "
2013-07-15 22:10:23 +00:00
else
2013-07-22 19:14:57 +00:00
touch " $MASTER_STATE_DIR /slave-deleted-list "
echo "slave-replica-deleted-list.empty" > " $MASTER_STATE_DIR /last-action "
2013-06-18 11:34:14 +00:00
fi
2013-07-18 20:41:31 +00:00
}
2013-07-15 22:10:23 +00:00
2013-07-18 20:41:31 +00:00
function sync_update_slave
{
Log "Updating slave replica."
2013-07-21 19:40:55 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-10-10 18:17:40 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" $RSYNC_ARGS -rlptgoDEui --stats -e \" $RSYNC_SSH_CMD \" $SLAVE_BACKUP --exclude \" $OSYNC_DIR \" $RSYNC_EXCLUDE --exclude-from \" $MASTER_STATE_DIR /master-deleted-list\" --exclude-from \" $MASTER_STATE_DIR /slave-deleted-list\" \" $MASTER_SYNC_DIR /\" $REMOTE_USER @ $REMOTE_HOST :\" $ESC_SLAVE_SYNC_DIR /\" > $RUN_DIR /osync_update_slave_replica_ $SCRIPT_PID 2>&1 & "
2013-07-21 19:40:55 +00:00
else
2013-10-10 18:17:40 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" $RSYNC_ARGS -rlptgoDEui --stats $SLAVE_BACKUP --exclude \" $OSYNC_DIR \" $RSYNC_EXCLUDE --exclude-from \" $MASTER_STATE_DIR /master-deleted-list\" --exclude-from \" $MASTER_STATE_DIR /slave-deleted-list\" \" $MASTER_SYNC_DIR /\" \" $SLAVE_SYNC_DIR /\" > $RUN_DIR /osync_update_slave_replica_ $SCRIPT_PID 2>&1 & "
2013-07-21 19:40:55 +00:00
fi
2013-07-23 18:57:38 +00:00
if [ " $DEBUG " = = "yes" ]
then
Log " RSYNC_CMD: $rsync_cmd "
fi
2013-07-24 08:38:42 +00:00
eval " $rsync_cmd "
2013-07-18 20:41:31 +00:00
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME $HARD_MAX_EXEC_TIME
retval = $?
2013-10-10 18:17:40 +00:00
if [ $verbose -eq 1 ] && [ -f $RUN_DIR /osync_update_slave_replica_$SCRIPT_PID ]
2013-07-19 23:00:58 +00:00
then
2013-10-10 18:17:40 +00:00
Log " List:\n $( cat $RUN_DIR /osync_update_slave_replica_$SCRIPT_PID ) "
2013-07-19 23:00:58 +00:00
fi
2013-07-18 20:41:31 +00:00
if [ $retval != 0 ]
then
LogError "Updating slave replica failed. Stopping execution."
2013-10-10 18:17:40 +00:00
if [ $verbose -eq 0 ] && [ -f $RUN_DIR /osync_update_slave_replica_$SCRIPT_PID ]
2013-08-25 10:37:37 +00:00
then
2013-10-10 18:17:40 +00:00
LogError " Rsync output:\n $( cat $RUN_DIR /osync_update_slave_replica_$SCRIPT_PID ) "
2013-08-25 10:37:37 +00:00
fi
2013-07-22 19:14:57 +00:00
echo "update-slave-replica.fail" > " $MASTER_STATE_DIR /last-action "
2013-07-19 23:00:58 +00:00
exit 1
2013-07-18 20:41:31 +00:00
else
Log "Updating slave replica succeded."
2013-07-22 19:14:57 +00:00
echo "update-slave-replica.success" > " $MASTER_STATE_DIR /last-action "
2013-07-18 20:41:31 +00:00
fi
}
function sync_update_master
{
Log "Updating master replica."
2013-07-21 19:40:55 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-10-10 18:17:40 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) $RSYNC_ARGS -rlptgoDEui --stats -e \" $RSYNC_SSH_CMD \" $MASTER_BACKUP --exclude \" $OSYNC_DIR \" $RSYNC_EXCLUDE --exclude-from \" $MASTER_STATE_DIR /slave-deleted-list\" --exclude-from \" $MASTER_STATE_DIR /master-deleted-list\" $REMOTE_USER @ $REMOTE_HOST :\" $ESC_SLAVE_SYNC_DIR /\" \" $MASTER_SYNC_DIR \" > $RUN_DIR /osync_update_master_replica_ $SCRIPT_PID 2>&1 & "
2013-07-21 19:40:55 +00:00
else
2013-10-10 18:17:40 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" $RSYNC_ARGS -rlptgoDEui --stats $MASTER_BACKUP --exclude \" $OSYNC_DIR \" $RSYNC_EXCLUDE --exclude-from \" $MASTER_STATE_DIR /slave-deleted-list\" --exclude-from \" $MASTER_STATE_DIR /master-deleted-list\" \" $SLAVE_SYNC_DIR /\" \" $MASTER_SYNC_DIR /\" > $RUN_DIR /osync_update_master_replica_ $SCRIPT_PID 2>&1 & "
2013-07-23 18:57:38 +00:00
fi
if [ " $DEBUG " = = "yes" ]
then
Log " RSYNC_CMD: $rsync_cmd "
2013-07-21 19:40:55 +00:00
fi
2013-07-24 08:38:42 +00:00
eval " $rsync_cmd "
2013-07-18 20:41:31 +00:00
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME $HARD_MAX_EXEC_TIME
retval = $?
2013-10-10 18:17:40 +00:00
if [ $verbose -eq 1 ] && [ -f $RUN_DIR /osync_update_master_replica_$SCRIPT_PID ]
2013-07-19 23:00:58 +00:00
then
2013-10-10 18:17:40 +00:00
Log " List:\n $( cat $RUN_DIR /osync_update_master_replica_$SCRIPT_PID ) "
2013-07-19 23:00:58 +00:00
fi
2013-07-18 20:41:31 +00:00
if [ $retval != 0 ]
then
2013-10-10 18:17:40 +00:00
if [ $verbose -eq 0 ] && [ -f $RUN_DIR /osync_update_slave_replica_$SCRIPT_PID ]
2013-08-25 10:37:37 +00:00
then
2013-10-10 18:17:40 +00:00
LogError " Rsync output:\n $( cat $RUN_DIR /osync_update_slave_replica_$SCRIPT_PID ) "
2013-08-25 10:37:37 +00:00
fi
2013-07-18 20:41:31 +00:00
LogError "Updating master replica failed. Stopping execution."
2013-07-22 19:14:57 +00:00
echo "update-master-replica.fail" > " $MASTER_STATE_DIR /last-action "
2013-07-19 23:00:58 +00:00
exit 1
2013-07-18 20:41:31 +00:00
else
Log "Updating master replica succeded."
2013-07-22 19:14:57 +00:00
echo "update-master-replica.success" > " $MASTER_STATE_DIR /last-action "
2013-07-18 20:41:31 +00:00
fi
}
function delete_on_slave
{
2013-08-04 07:47:47 +00:00
Log "Propagating deletions to slave replica."
2013-07-21 19:40:55 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-10-10 18:17:40 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" $RSYNC_ARGS -rlptgoDEui --stats -e \" $RSYNC_SSH_CMD \" $SLAVE_DELETE --delete --exclude \" $OSYNC_DIR \" --include-from \" $MASTER_STATE_DIR /master-deleted-list\" --exclude=\"*\" \" $MASTER_SYNC_DIR /\" $REMOTE_USER @ $REMOTE_HOST :\" $ESC_SLAVE_SYNC_DIR /\" > $RUN_DIR /osync_deletion_on_slave_ $SCRIPT_PID 2>&1 & "
2013-07-21 19:40:55 +00:00
else
2013-10-10 18:17:40 +00:00
#rsync_cmd="$(type -p $RSYNC_EXECUTABLE) --rsync-path=\"$RSYNC_PATH\" $RSYNC_ARGS -rlptgoDEui --stats $SLAVE_DELETE --delete --exclude \"$OSYNC_DIR\" $RSYNC_EXCLUDE --exclude-from \"$MASTER_STATE_DIR/slave-deleted-list\" --include-from \"$MASTER_STATE_DIR/master-deleted-list\" \"$MASTER_SYNC_DIR/\" \"$SLAVE_SYNC_DIR/\" > $RUN_DIR/osync_deletion_on_slave_$SCRIPT_PID 2>&1 &"
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" $RSYNC_ARGS -rlptgoDEui --stats $SLAVE_DELETE --delete --exclude \" $OSYNC_DIR \" --include-from \" $MASTER_STATE_DIR /master-deleted-list\" --exclude=\"*\" \" $MASTER_SYNC_DIR /\" \" $SLAVE_SYNC_DIR /\" > $RUN_DIR /osync_deletion_on_slave_ $SCRIPT_PID 2>&1 & "
2013-07-23 18:57:38 +00:00
fi
if [ " $DEBUG " = = "yes" ]
then
Log " RSYNC_CMD: $rsync_cmd "
2013-07-21 19:40:55 +00:00
fi
2013-07-24 08:38:42 +00:00
eval " $rsync_cmd "
2013-07-16 21:06:26 +00:00
child_pid = $!
2013-07-18 11:39:52 +00:00
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME 0
2013-07-17 09:34:05 +00:00
retval = $?
2013-10-10 18:17:40 +00:00
if [ $verbose -eq 1 ] && [ -f $RUN_DIR /osync_deletion_on_slave_$SCRIPT_PID ]
2013-07-19 23:00:58 +00:00
then
2013-10-10 18:17:40 +00:00
Log " List:\n $( cat $RUN_DIR /osync_deletion_on_slave_$SCRIPT_PID ) "
2013-07-19 23:00:58 +00:00
fi
2013-07-17 09:34:05 +00:00
if [ $retval != 0 ]
2013-07-16 21:06:26 +00:00
then
2013-10-10 18:17:40 +00:00
if [ $verbose -eq 0 ] && [ -f $RUN_DIR /osync_deletion_on_slave_$SCRIPT_PID ]
2013-08-25 10:37:37 +00:00
then
2013-10-10 18:17:40 +00:00
LogError " Rsync output:\n $( cat $RUN_DIR /osync_deletion_on_slave_$SCRIPT_PID ) "
2013-08-25 10:37:37 +00:00
fi
2013-08-04 07:47:47 +00:00
LogError "Deletion on slave failed."
2013-07-22 19:14:57 +00:00
echo "delete-propagation-slave.fail" > " $MASTER_STATE_DIR /last-action "
2013-07-19 23:00:58 +00:00
exit 1
2013-07-18 20:41:31 +00:00
else
2013-07-22 19:14:57 +00:00
echo "delete-propagation-slave.success" > " $MASTER_STATE_DIR /last-action "
2013-07-16 21:06:26 +00:00
fi
2013-07-18 20:41:31 +00:00
}
function delete_on_master
{
2013-08-04 07:47:47 +00:00
Log "Propagating deletions to master replica."
2013-07-21 19:40:55 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-10-10 18:17:40 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" $RSYNC_ARGS -rlptgoDEui --stats -e \" $RSYNC_SSH_CMD \" $MASTER_DELETE --delete --exclude \" $OSYNC_DIR \" --include-from \" $MASTER_STATE_DIR /slave-deleted-list\" --exclude=\"*\" $REMOTE_USER @ $REMOTE_HOST :\" $ESC_SLAVE_SYNC_DIR /\" \" $MASTER_SYNC_DIR /\" > $RUN_DIR /osync_deletion_on_master_ $SCRIPT_PID 2>&1 & "
2013-07-21 19:40:55 +00:00
else
2013-10-10 18:17:40 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" $RSYNC_ARGS -rlptgoDEui --stats $MASTER_DELETE --delete --exclude \" $OSYNC_DIR \" --include-from \" $MASTER_STATE_DIR /slave-deleted-list\" --exclude=\"*\" \" $SLAVE_SYNC_DIR /\" \" $MASTER_SYNC_DIR /\" > $RUN_DIR /osync_deletion_on_master_ $SCRIPT_PID 2>&1 & "
2013-07-23 18:57:38 +00:00
fi
if [ " $DEBUG " = = "yes" ]
then
Log " RSYNC_CMD: $rsync_cmd "
2013-07-21 19:40:55 +00:00
fi
2013-07-24 08:38:42 +00:00
eval " $rsync_cmd "
2013-07-16 21:06:26 +00:00
child_pid = $!
2013-07-18 11:39:52 +00:00
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME 0
2013-07-17 09:34:05 +00:00
retval = $?
2013-10-10 18:17:40 +00:00
if [ $verbose -eq 1 ] && [ -f $RUN_DIR /osync_deletion_on_master_$SCRIPT_PID ]
2013-07-19 23:00:58 +00:00
then
2013-10-10 18:17:40 +00:00
Log " List:\n $( cat $RUN_DIR /osync_deletion_on_master_$SCRIPT_PID ) "
2013-07-19 23:00:58 +00:00
fi
2013-07-17 09:34:05 +00:00
if [ $retval != 0 ]
2013-07-16 21:06:26 +00:00
then
2013-10-10 18:17:40 +00:00
if [ $verbose -eq 0 ] && [ -f $RUN_DIR /osync_deletion_on_master_$SCRIPT_PID ]
2013-08-25 10:37:37 +00:00
then
2013-10-10 18:17:40 +00:00
LogError " Rsync output:\n $( cat $RUN_DIR /osync_deletion_on_master_$SCRIPT_PID ) "
2013-08-25 10:37:37 +00:00
fi
2013-08-04 07:47:47 +00:00
LogError "Deletion on master failed."
2013-07-22 19:14:57 +00:00
echo "delete-propagation-master.fail" > " $MASTER_STATE_DIR /last-action "
2013-07-19 23:00:58 +00:00
exit 1
2013-07-18 20:41:31 +00:00
else
2013-07-22 19:14:57 +00:00
echo "delete-propagation-master.success" > " $MASTER_STATE_DIR /last-action "
2013-07-16 21:06:26 +00:00
fi
2013-07-18 20:41:31 +00:00
}
2013-07-15 22:10:23 +00:00
2013-07-21 19:40:55 +00:00
function master_tree_after
2013-07-18 20:41:31 +00:00
{
2013-08-04 13:20:26 +00:00
if [ $dryrun -eq 1 ]
then
Log "No need to create after run master replica file list, nothing should have changed."
return 0
fi
2013-07-21 19:40:55 +00:00
Log "Creating after run master replica file list."
2013-10-10 18:17:40 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" -rlptgoDE8 $RSYNC_ARGS --exclude \" $OSYNC_DIR \" $RSYNC_EXCLUDE --list-only \" $MASTER_SYNC_DIR /\" | grep \"^-\|^d\" | awk '{\$1=\$2=\$3=\$4=\"\" ;print}' | awk '{\$1=\$1 ;print}' | (grep -v \"^\. $\" || :) | sort > $RUN_DIR /osync_master-tree-after_ $SCRIPT_PID & "
2013-08-04 13:27:31 +00:00
if [ " $DEBUG " = = "yes" ]
then
Log " RSYNC_CMD: $rsync_cmd "
fi
eval $rsync_cmd
2013-07-16 21:06:26 +00:00
child_pid = $!
2013-07-18 11:39:52 +00:00
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME 0
2013-07-16 21:06:26 +00:00
retval = $?
2013-10-10 18:17:40 +00:00
if [ $retval = = 0 ] && [ -f $RUN_DIR /osync_master-tree-after_$SCRIPT_PID ]
2013-07-16 21:06:26 +00:00
then
2013-10-10 18:17:40 +00:00
mv $RUN_DIR /osync_master-tree-after_$SCRIPT_PID " $MASTER_STATE_DIR /master-tree-after "
2013-07-22 19:14:57 +00:00
echo "master-replica-tree-after.success" > " $MASTER_STATE_DIR /last-action "
2013-07-16 21:06:26 +00:00
else
LogError "Cannot create slave file list."
2013-07-22 19:14:57 +00:00
echo "master-replica-tree-after.fail" > " $MASTER_STATE_DIR /last-action "
2013-07-19 23:00:58 +00:00
exit 1
2013-07-16 21:06:26 +00:00
fi
2013-07-18 20:41:31 +00:00
}
2013-07-16 21:06:26 +00:00
2013-07-21 19:40:55 +00:00
function slave_tree_after
2013-07-18 20:41:31 +00:00
{
2013-08-04 13:20:26 +00:00
if [ $dryrun -eq 1 ]
then
Log "No need to create after frun slave replica file list, nothing should have changed."
return 0
fi
2013-07-21 19:40:55 +00:00
Log "Creating after run slave replica file list."
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-10-10 18:17:40 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" -rlptgoDE8 $RSYNC_ARGS -e \" $RSYNC_SSH_CMD \" --exclude \" $OSYNC_DIR \" $RSYNC_EXCLUDE --list-only $REMOTE_USER @ $REMOTE_HOST :\" $ESC_SLAVE_SYNC_DIR /\" | grep \"^-\|^d\" | awk '{\$1=\$2=\$3=\$4=\"\" ;print}' | awk '{\$1=\$1 ;print}' | (grep -v \"^\. $\" || :) | sort > $RUN_DIR /osync_slave-tree-after_ $SCRIPT_PID & "
2013-07-21 19:40:55 +00:00
else
2013-10-10 18:17:40 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" -rlptgoDE8 $RSYNC_ARGS --exclude \" $OSYNC_DIR \" $RSYNC_EXCLUDE --list-only \" $SLAVE_SYNC_DIR /\" | grep \"^-\|^d\" | awk '{\$1=\$2=\$3=\$4=\"\" ;print}' | awk '{\$1=\$1 ;print}' | (grep -v \"^\. $\" || :) | sort > $RUN_DIR /osync_slave-tree-after_ $SCRIPT_PID & "
2013-07-21 19:40:55 +00:00
fi
2013-07-24 08:38:42 +00:00
if [ " $DEBUG " = = "yes" ]
then
Log " RSYNC_CMD: $rsync_cmd "
fi
eval $rsync_cmd
2013-07-16 21:06:26 +00:00
child_pid = $!
2013-07-18 11:39:52 +00:00
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME 0
2013-07-16 21:06:26 +00:00
retval = $?
2013-10-10 18:17:40 +00:00
if [ $retval = = 0 ] && [ -f $RUN_DIR /osync_slave-tree-after_$SCRIPT_PID ]
2013-07-16 21:06:26 +00:00
then
2013-10-10 18:17:40 +00:00
mv $RUN_DIR /osync_slave-tree-after_$SCRIPT_PID " $MASTER_STATE_DIR /slave-tree-after "
2013-07-22 19:14:57 +00:00
echo "slave-replica-tree-after.success" > " $MASTER_STATE_DIR /last-action "
2013-07-16 21:06:26 +00:00
else
LogError "Cannot create slave file list."
2013-07-22 19:14:57 +00:00
echo "slave-replica-tree-after.fail" > " $MASTER_STATE_DIR /last-action "
2013-07-19 23:00:58 +00:00
exit 1
2013-07-16 21:06:26 +00:00
fi
2013-07-18 20:41:31 +00:00
}
2013-07-19 10:49:40 +00:00
###### Sync function in 10 steps (functions above)
2013-07-18 20:41:31 +00:00
function Sync
{
Log "Starting synchronization task."
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-07-18 20:41:31 +00:00
2013-07-22 19:14:57 +00:00
if [ -f " $MASTER_STATE_DIR /last-action " ] && [ " $RESUME_SYNC " = = "yes" ]
2013-07-18 20:41:31 +00:00
then
2013-07-22 19:14:57 +00:00
resume_sync = $( cat " $MASTER_STATE_DIR /last-action " )
if [ -f " $MASTER_STATE_DIR /resume-count " ]
2013-07-19 10:49:40 +00:00
then
2013-07-22 19:14:57 +00:00
resume_count = $( cat " $MASTER_STATE_DIR /resume-count " )
2013-07-19 10:49:40 +00:00
else
resume_count = 0
fi
if [ $resume_count -lt $RESUME_TRY ]
2013-07-18 20:41:31 +00:00
then
2013-07-19 10:49:40 +00:00
if [ " $resume_sync " != "sync.success" ]
then
2013-07-31 00:26:53 +00:00
Log " WARNING: Trying to resume aborted osync execution on $( stat --format %y " $MASTER_STATE_DIR /last-action " ) at task [ $resume_sync ]. [ $resume_count ] previous tries. "
2013-07-22 19:14:57 +00:00
echo $(( $resume_count + 1 )) > " $MASTER_STATE_DIR /resume-count "
2013-07-19 10:49:40 +00:00
else
resume_sync = none
fi
2013-07-18 20:41:31 +00:00
else
2013-07-19 23:00:58 +00:00
Log " Will not resume aborted osync execution. Too much resume tries [ $resume_count ]. "
2013-07-22 19:14:57 +00:00
echo "noresume" > " $MASTER_STATE_DIR /last-action "
echo "0" > " $MASTER_STATE_DIR /resume-count "
2013-07-18 20:41:31 +00:00
resume_sync = none
fi
else
resume_sync = none
fi
2013-07-30 22:18:39 +00:00
################################################################################################################################################# Actual sync begins here
## This replaces the case statement below because ;& operator is not supported in bash 3.2... Code is more messy than case :(
2013-08-04 13:27:31 +00:00
if [ " $resume_sync " = = "none" ] || [ " $resume_sync " = = "noresume" ] || [ " $resume_sync " = = "master-replica-tree.fail" ]
2013-07-30 22:18:39 +00:00
then
2013-07-18 20:41:31 +00:00
master_tree_current
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = "master-replica-tree.success" ] || [ " $resume_sync " = = "slave-replica-tree.fail" ]
then
2013-07-18 20:41:31 +00:00
slave_tree_current
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = "slave-replica-tree.success" ] || [ " $resume_sync " = = "master-replica-deleted-list.fail" ]
then
2013-07-18 20:41:31 +00:00
master_delete_list
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = "master-replica-deleted-list.success" ] || [ " $resume_sync " = = "slave-replica-deleted-list.fail" ]
then
2013-07-18 20:41:31 +00:00
slave_delete_list
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = "slave-replica-deleted-list.success" ] || [ " $resume_sync " = = "update-master-replica.fail" ] || [ " $resume_sync " = = "update-slave-replica.fail" ]
then
if [ " $CONFLICT_PREVALANCE " != "master" ]
then
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = "slave-replica-deleted-list.success" ] || [ " $resume_sync " = = "update-master-replica.fail" ]
then
2013-07-19 10:49:40 +00:00
sync_update_master
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = "update-master-replica.success" ] || [ " $resume_sync " = = "update-slave-replica.fail" ]
then
2013-07-19 10:49:40 +00:00
sync_update_slave
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
else
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = "slave-replica-deleted-list.success" ] || [ " $resume_sync " = = "update-slave-replica.fail" ]
then
sync_update_slave
resume_sync = "resumed"
fi
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = "update-slave-replica.success" ] || [ " $resume_sync " = = "update-master-replica.fail" ]
then
sync_update_master
resume_sync = "resumed"
fi
fi
fi
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = "update-slave-replica.success" ] || [ " $resume_sync " = = "update-master-replica.success" ] || [ " $resume_sync " = = "delete-propagation-slave.fail" ]
then
2013-07-18 20:41:31 +00:00
delete_on_slave
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = "delete-propagation-slave.success" ] || [ " $resume_sync " = = "delete-propagation-master.fail" ]
then
2013-07-18 20:41:31 +00:00
delete_on_master
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = "delete-propagation-master.success" ] || [ " $resume_sync " = = "master-replica-tree-after.fail" ]
then
2013-07-21 19:40:55 +00:00
master_tree_after
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = "master-replica-tree-after.success" ] || [ " $resume_sync " = = "slave-replica-tree-after.fail" ]
then
2013-07-21 19:40:55 +00:00
slave_tree_after
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
# ## In this case statement, ;& means executing every command below regardless of conditions. Only works with bash v4
# case $resume_sync in
# none|noresume)
# ;&
# master-replica-tree.fail)
# master_tree_current
# ;&
# master-replica-tree.success|slave-replica-tree.fail)
# slave_tree_current
# ;&
# slave-replica-tree.success|master-replica-deleted-list.fail)
# master_delete_list
# ;&
# master-replica-deleted-list.success|slave-replica-deleted-list.fail)
# slave_delete_list
# ;&
# slave-replica-deleted-list.success|update-master-replica.fail|update-slave-replica.fail)
# if [ "$CONFLICT_PREVALANCE" != "master" ]
# then
# case $resume_sync in
# none)
# ;&
# slave-replica-deleted-list.success|update-master-replica.fail)
# sync_update_master
# ;&
# update-master-replica.success|update-slave-replica.fail)
2013-08-04 07:47:47 +00:00
# sync_update_slave
2013-07-30 22:18:39 +00:00
# ;;
# esac
# else
# case $resume_sync in
# none)
# ;&
# slave-replica-deleted-list.success|update-slave-replica.fail)
# sync_update_slave
# ;&
# update-slave-replica.success|update-master-replica.fail)
# sync_update_master
# ;;
# esac
# fi
# ;&
# update-slave-replica.success|update-master-replica.success|delete-propagation-slave.fail)
# delete_on_slave
# ;&
# delete-propagation-slave.success|delete-propagation-master.fail)
# delete_on_master
# ;&
# delete-propagation-master.success|master-replica-tree-after.fail)
# master_tree_after
# ;&
# master-replica-tree-after.success|slave-replica-tree-after.fail)
# slave_tree_after
# ;;
# esac
2013-07-15 22:10:23 +00:00
Log "Finished synchronization task."
2013-07-22 19:14:57 +00:00
echo "sync.success" > " $MASTER_STATE_DIR /last-action "
echo "0" > " $MASTER_STATE_DIR /resume-count "
2013-07-18 20:41:31 +00:00
}
2013-07-15 22:10:23 +00:00
function SoftDelete
2013-06-18 11:34:14 +00:00
{
2013-11-02 22:33:54 +00:00
if [ " $CONFLICT_BACKUP " != "no" ] && [ $CONFLICT_BACKUP_DAYS -ne 0 ]
2013-07-16 11:55:15 +00:00
then
2013-07-22 19:14:57 +00:00
if [ -d " $MASTER_BACKUP_DIR " ]
2013-07-16 11:55:15 +00:00
then
Log " Removing backups older than $CONFLICT_BACKUP_DAYS days on master replica. "
2013-08-03 21:06:09 +00:00
if [ $dryrun -eq 1 ]
then
2013-10-10 18:17:40 +00:00
$FIND_CMD " $MASTER_BACKUP_DIR / " -ctime +$CONFLICT_BACKUP_DAYS &
2013-08-03 21:06:09 +00:00
else
2013-10-10 18:17:40 +00:00
$FIND_CMD " $MASTER_BACKUP_DIR / " -ctime +$CONFLICT_BACKUP_DAYS | xargs rm -rf &
2013-08-04 13:20:26 +00:00
fi
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME 0
retval = $?
if [ $retval -ne 0 ]
then
LogError "Error while executing conflict backup cleanup on master replica."
else
Log "Conflict backup cleanup complete on master replica."
2013-08-03 21:06:09 +00:00
fi
2013-11-02 20:57:15 +00:00
elif [ -d " $MASTER_BACKUP_DIR " ] && ! [ -w " $MASTER_BACKUP_DIR " ]
then
LogError " Warning: Master replica conflict backup dir [ $MASTER_BACKUP_DIR ] isn't writable. Cannot clean old files. "
2013-07-16 11:55:15 +00:00
fi
2013-07-21 19:40:55 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
2013-07-16 11:55:15 +00:00
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-07-21 19:40:55 +00:00
Log " Removing backups older than $CONFLICT_BACKUP_DAYS days on remote slave replica. "
2013-08-03 21:06:09 +00:00
if [ $dryrun -eq 1 ]
then
2013-11-02 20:57:15 +00:00
eval " $SSH_CMD \"if [ -w \\\" $SLAVE_BACKUP_DIR \\\" ]; then $COMMAND_SUDO $REMOTE_FIND_CMD \\\" $SLAVE_BACKUP_DIR /\\\" -ctime + $CONFLICT_BACKUP_DAYS ; fi\" "
2013-08-03 21:06:09 +00:00
else
2013-11-02 20:57:15 +00:00
eval " $SSH_CMD \"if [ -w \\\" $SLAVE_BACKUP_DIR \\\" ]; then $COMMAND_SUDO $REMOTE_FIND_CMD \\\" $SLAVE_BACKUP_DIR /\\\" -ctime + $CONFLICT_BACKUP_DAYS | xargs rm -rf; fi\" "
2013-08-03 21:06:09 +00:00
fi
2013-08-04 13:20:26 +00:00
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME 0
retval = $?
if [ $retval -ne 0 ]
then
LogError "Error while executing conflict backup cleanup on slave replica."
else
Log "Conflict backup cleanup complete on slave replica."
fi
2013-07-21 19:40:55 +00:00
else
2013-11-02 20:57:15 +00:00
if [ -w " $SLAVE_BACKUP_DIR " ]
2013-07-21 19:40:55 +00:00
then
Log " Removing backups older than $CONFLICT_BACKUP_DAYS days on slave replica. "
2013-08-03 21:06:09 +00:00
if [ $dryrun -eq 1 ]
then
2013-10-10 18:17:40 +00:00
$FIND_CMD " $SLAVE_BACKUP_DIR / " -ctime +$CONFLICT_BACKUP_DAYS
2013-08-03 21:06:09 +00:00
else
2013-10-10 18:17:40 +00:00
$FIND_CMD " $SLAVE_BACKUP_DIR / " -ctime +$CONFLICT_BACKUP_DAYS | xargs rm -rf
2013-08-03 21:06:09 +00:00
fi
2013-08-04 13:20:26 +00:00
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME 0
retval = $?
if [ $retval -ne 0 ]
then
LogError "Error while executing conflict backup cleanup on slave replica."
else
Log "Conflict backup cleanup complete on slave replica."
fi
2013-11-02 20:57:15 +00:00
elif [ -d " $SLAVE_BACKUP_DIR " ] && ! [ -w " $SLAVE_BACKUP_DIR " ]
then
LogError " Warning: Slave replica conflict backup dir [ $SLAVE_BACKUP_DIR ] isn't writable. Cannot clean old files. "
2013-07-21 19:40:55 +00:00
fi
2013-07-16 11:55:15 +00:00
fi
fi
2013-11-02 22:33:54 +00:00
if [ " $SOFT_DELETE " != "no" ] && [ $SOFT_DELETE_DAYS -ne 0 ]
2013-07-16 11:55:15 +00:00
then
2013-11-02 20:57:15 +00:00
if [ -w " $MASTER_DELETE_DIR " ]
2013-07-16 11:55:15 +00:00
then
Log " Removing soft deleted items older than $SOFT_DELETE_DAYS days on master replica. "
2013-08-03 21:06:09 +00:00
if [ $dryrun -eq 1 ]
then
2013-10-10 18:17:40 +00:00
$FIND_CMD " $MASTER_DELETE_DIR / " -ctime +$SOFT_DELETE_DAYS
2013-08-03 21:06:09 +00:00
else
2013-10-10 18:17:40 +00:00
$FIND_CMD " $MASTER_DELETE_DIR / " -ctime +$SOFT_DELETE_DAYS | xargs rm -rf
2013-08-03 21:06:09 +00:00
fi
2013-08-04 13:20:26 +00:00
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME 0
retval = $?
if [ $retval -ne 0 ]
then
LogError "Error while executing soft delete cleanup on master replica."
else
Log "Soft delete cleanup complete on master replica."
fi
2013-11-02 20:57:15 +00:00
elif [ -d " $MASTER_DELETE_DIR " ] && ! [ -w $MASTER_DELETE_DIR ]
then
LogError " Warning: Master replica deletion backup dir [ $MASTER_DELETE_DIR ] isn't writable. Cannot clean old files. "
2013-07-16 11:55:15 +00:00
fi
2013-07-21 19:40:55 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
2013-07-16 11:55:15 +00:00
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-07-21 19:40:55 +00:00
Log " Removing soft deleted items older than $SOFT_DELETE_DAYS days on remote slave replica. "
2013-08-03 21:06:09 +00:00
if [ $dryrun -eq 1 ]
then
2013-11-02 20:57:15 +00:00
eval " $SSH_CMD \"if [ -w \\\" $SLAVE_DELETE_DIR \\\" ]; then $COMMAND_SUDO $REMOTE_FIND_CMD \\\" $SLAVE_DELETE_DIR /\\\" -ctime + $SOFT_DELETE_DAYS ; fi\" "
2013-08-03 21:06:09 +00:00
else
2013-11-02 20:57:15 +00:00
eval " $SSH_CMD \"if [ -w \\\" $SLAVE_DELETE_DIR \\\" ]; then $COMMAND_SUDO $REMOTE_FIND_CMD \\\" $SLAVE_DELETE_DIR /\\\" -ctime + $SOFT_DELETE_DAYS | xargs rm -rf; fi\" "
2013-08-03 21:06:09 +00:00
fi
2013-08-04 13:20:26 +00:00
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME 0
retval = $?
if [ $retval -ne 0 ]
then
LogError "Error while executing soft delete cleanup on slave replica."
else
Log "Soft delete cleanup complete on slave replica."
fi
2013-07-21 19:40:55 +00:00
else
2013-11-02 20:57:15 +00:00
if [ -w " $SLAVE_DELETE_DIR " ]
2013-07-21 19:40:55 +00:00
then
Log " Removing soft deleted items older than $SOFT_DELETE_DAYS days on slave replica. "
2013-08-03 21:06:09 +00:00
if [ $dryrun -eq 1 ]
then
2013-10-10 18:17:40 +00:00
$FIND_CMD " $SLAVE_DELETE_DIR / " -ctime +$SOFT_DELETE_DAYS
2013-08-03 21:06:09 +00:00
else
2013-10-10 18:17:40 +00:00
$FIND_CMD " $SLAVE_DELETE_DIR / " -ctime +$SOFT_DELETE_DAYS | xargs rm -rf
2013-08-03 21:06:09 +00:00
fi
2013-08-04 13:20:26 +00:00
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME 0
retval = $?
if [ $retval -ne 0 ]
then
LogError "Error while executing soft delete cleanup on slave replica."
else
Log "Soft delete cleanup complete on slave replica."
fi
2013-11-02 20:57:15 +00:00
elif [ -d " $SLAVE_DELETE_DIR " ] && ! [ -w " $SLAVE_DELETE_DIR " ]
then
LogError " Warning: Slave replica deletion backup dir [ $SLAVE_DELETE_DIR ] isn't writable. Cannot clean old files. "
2013-07-21 19:40:55 +00:00
fi
2013-07-16 11:55:15 +00:00
fi
fi
2013-07-15 22:10:23 +00:00
}
function Init
{
# Set error exit code if a piped command fails
set -o pipefail
set -o errtrace
2013-07-17 09:34:05 +00:00
trap TrapStop SIGINT SIGKILL SIGHUP SIGTERM SIGQUIT
trap TrapQuit EXIT
2013-07-15 22:10:23 +00:00
if [ " $DEBUG " = = "yes" ]
2013-06-18 11:34:14 +00:00
then
2013-07-24 08:38:42 +00:00
trap 'TrapError ${LINENO} $?' ERR
2013-06-18 11:34:14 +00:00
fi
2013-07-15 22:10:23 +00:00
2013-08-18 11:15:40 +00:00
if [ " $LOGFILE " = = "" ]
then
2013-11-02 20:57:15 +00:00
if [ -w /var/log ]
2013-10-10 18:17:40 +00:00
then
LOG_FILE = /var/log/osync_$OSYNC_VERSION -$SYNC_ID .log
else
LOG_FILE = ./osync_$OSYNC_VERSION -$SYNC_ID .log
fi
2013-08-18 11:15:40 +00:00
else
LOG_FILE = " $LOGFILE "
fi
2013-07-15 22:10:23 +00:00
MAIL_ALERT_MSG = " Warning: Execution of osync instance $OSYNC_ID (pid $SCRIPT_PID ) as $LOCAL_USER @ $LOCAL_HOST produced errors. "
2013-10-10 18:17:40 +00:00
## If running Msys, find command of windows is used instead of msys one
2013-10-11 19:35:20 +00:00
if [ " $LOCAL_OS " = = "msys" ]
2013-10-10 18:17:40 +00:00
then
FIND_CMD = $( dirname $BASH ) /find
else
FIND_CMD = find
fi
2013-10-11 19:35:20 +00:00
if [ " $REMOTE_OS " = = "msys" ]
then
REMOTE_FIND_CMD = $( dirname $BASH ) /find
else
REMOTE_FIND_CMD = find
fi
2013-10-10 18:17:40 +00:00
2013-07-24 08:38:42 +00:00
## Rsync does not like spaces in directory names, considering it as two different directories. Handling this schema by escaping space
2013-07-24 08:55:28 +00:00
## It seems this only happens when trying to execute an rsync command through eval $rsync_cmd... on a remote host. This is freaking unholy to find a workaround...
2013-10-10 18:17:40 +00:00
## So actually use $MASTER_SYNC_DIR for local rsync calls and $ESC_MASTER_SYNC_DIR for remote rsync calls like user@host:$ESC_MASTER_SYNC_DIR
2013-07-24 08:55:28 +00:00
## The same applies for slave sync dir..............................................T.H.I.S..I.S..A..P.R.O.G.R.A.M.M.I.N.G..N.I.G.H.T.M.A.R.E
2013-07-24 08:38:42 +00:00
ESC_MASTER_SYNC_DIR = $( EscapeSpaces " $MASTER_SYNC_DIR " )
ESC_SLAVE_SYNC_DIR = $( EscapeSpaces " $SLAVE_SYNC_DIR " )
2013-07-21 19:40:55 +00:00
MASTER_STATE_DIR = " $MASTER_SYNC_DIR / $OSYNC_DIR /state "
SLAVE_STATE_DIR = " $SLAVE_SYNC_DIR / $OSYNC_DIR /state "
2013-07-15 22:10:23 +00:00
## Working directories to keep backups of updated / deleted files
2013-07-24 08:38:42 +00:00
MASTER_BACKUP_DIR = " $OSYNC_DIR /backups "
MASTER_DELETE_DIR = " $OSYNC_DIR /deleted "
SLAVE_BACKUP_DIR = " $OSYNC_DIR /backups "
SLAVE_DELETE_DIR = " $OSYNC_DIR /deleted "
2013-07-16 11:55:15 +00:00
2013-07-17 09:34:05 +00:00
## SSH compression
2013-11-03 19:29:17 +00:00
if [ " $SSH_COMPRESSION " != "no" ]
2013-07-17 09:34:05 +00:00
then
SSH_COMP = -C
else
SSH_COMP =
fi
2013-07-20 11:43:11 +00:00
## Define which runner (local bash or distant ssh) to use for standard commands and rsync commands
2013-07-16 11:55:15 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-10-10 18:17:40 +00:00
SSH_CMD = " $( type -p ssh) $SSH_COMP -i $SSH_RSA_PRIVATE_KEY $REMOTE_USER @ $REMOTE_HOST -p $REMOTE_PORT "
RSYNC_SSH_CMD = " $( type -p ssh) $SSH_COMP -i $SSH_RSA_PRIVATE_KEY -p $REMOTE_PORT "
2013-07-16 11:55:15 +00:00
fi
2013-07-16 21:06:26 +00:00
2013-10-10 18:28:40 +00:00
## Support for older config files without RSYNC_EXECUTABLE option
2013-07-22 09:34:58 +00:00
if [ " $RSYNC_EXECUTABLE " = = "" ]
then
RSYNC_EXECUTABLE = rsync
fi
2013-10-10 18:28:40 +00:00
## Sudo execution option
2013-07-22 09:34:58 +00:00
if [ " $SUDO_EXEC " = = "yes" ]
then
2013-10-10 18:28:40 +00:00
if [ " $RSYNC_REMOTE_PATH " != "" ]
then
RSYNC_PATH = " sudo $( type -p $RSYNC_REMOTE_PATH ) / $RSYNC_EXECUTABLE ) "
else
RSYNC_PATH = " sudo $RSYNC_EXECUTABLE "
fi
2013-07-22 09:34:58 +00:00
COMMAND_SUDO = "sudo"
else
2013-10-10 18:28:40 +00:00
if [ " $RSYNC_REMOTE_PATH " != "" ]
then
RSYNC_PATH = " $( type -p $RSYNC_REMOTE_PATH ) / $RSYNC_EXECUTABLE ) "
else
RSYNC_PATH = " $RSYNC_EXECUTABLE "
fi
2013-07-22 09:34:58 +00:00
COMMAND_SUDO = ""
fi
## Set rsync options
RSYNC_ARGS = "-"
2013-09-10 09:55:34 +00:00
if [ " $PRESERVE_ACL " = = "yes" ]
2013-07-22 09:34:58 +00:00
then
RSYNC_ARGS = $RSYNC_ARGS "A"
fi
if [ " $PRESERVE_XATTR " = = "yes" ]
then
RSYNC_ARGS = $RSYNC_ARGS "X"
fi
if [ " $RSYNC_COMPRESS " = = "yes" ]
then
RSYNC_ARGS = $RSYNC_ARGS "z"
fi
2013-07-16 21:06:26 +00:00
if [ $dryrun -eq 1 ]
then
2013-07-22 09:34:58 +00:00
RSYNC_ARGS = $RSYNC_ARGS "n"
2013-07-16 21:06:26 +00:00
DRY_WARNING = "/!\ DRY RUN"
2013-07-22 09:34:58 +00:00
fi
if [ " $RSYNC_ARGS " = = "-" ]
then
RSYNC_ARGS = ""
2013-07-16 21:33:30 +00:00
fi
2013-11-02 20:57:15 +00:00
if [ " $BANDWIDTH " != "" ] && [ " $BANDWIDTH " != "0" ]
2013-08-04 13:20:26 +00:00
then
RSYNC_ARGS = $RSYNC_ARGS " --bwlimit= $BANDWIDTH "
fi
2013-07-16 21:33:30 +00:00
## Conflict options
if [ " $CONFLICT_BACKUP " != "no" ]
then
2013-07-23 18:57:38 +00:00
MASTER_BACKUP = " --backup --backup-dir=\" $MASTER_BACKUP_DIR \" "
SLAVE_BACKUP = " --backup --backup-dir=\" $SLAVE_BACKUP_DIR \" "
2013-07-19 10:49:40 +00:00
if [ " $CONFLICT_BACKUP_MULTIPLE " = = "yes" ]
then
MASTER_BACKUP = " $MASTER_BACKUP --suffix . $( date +%Y.%m.%d-%H.%M.%S) "
SLAVE_BACKUP = " $SLAVE_BACKUP --suffix . $( date +%Y.%m.%d-%H.%M.%S) "
fi
2013-07-16 21:33:30 +00:00
else
2013-07-19 10:49:40 +00:00
MASTER_BACKUP =
SLAVE_BACKUP =
2013-07-16 21:33:30 +00:00
fi
## Soft delete options
if [ " $SOFT_DELETE " != "no" ]
then
2013-07-23 18:57:38 +00:00
MASTER_DELETE = " --backup --backup-dir=\" $MASTER_DELETE_DIR \" "
SLAVE_DELETE = " --backup --backup-dir=\" $SLAVE_DELETE_DIR \" "
2013-07-16 21:33:30 +00:00
else
MASTER_DELETE =
SLAVE_DELETE =
2013-07-16 21:06:26 +00:00
fi
2013-07-19 16:15:25 +00:00
## Add Rsync exclude patterns
RsyncExcludePattern
2013-06-18 11:34:14 +00:00
}
2013-07-15 22:10:23 +00:00
function Main
{
2013-07-20 11:43:11 +00:00
CreateOsyncDirs
2013-07-19 23:00:58 +00:00
LockDirectories
2013-07-15 22:10:23 +00:00
Sync
}
function Usage
2013-06-18 11:34:14 +00:00
{
2013-07-15 22:10:23 +00:00
echo " Osync $OSYNC_VERSION $OSYNC_BUILD "
echo ""
2013-11-03 19:29:17 +00:00
echo "You may use Osync with a configuration file, or use its default options for quick command line sync."
echo "Normal usage: osync /path/to/conf.file [--dry] [--silent] [--verbose] [--no-maxtime] [--force-unlock]"
echo "Quick usage: osync --master=/path/to/master/replica --slave=/path/to/slave/replica [--dry] [--silent] [--verbose] [--no-max-time] [--force-unlock]"
2013-07-15 22:10:23 +00:00
echo ""
2013-11-03 19:29:17 +00:00
echo "--dry: will run osync without actually doing anything; just testing"
2013-07-15 22:10:23 +00:00
echo "--silent: will run osync without any output to stdout, usefull for cron jobs"
2013-07-21 19:40:55 +00:00
echo "--verbose: adds command outputs"
2013-08-18 11:15:40 +00:00
echo "--no-maxtime: disables any soft and hard execution time checks"
2013-07-30 22:18:39 +00:00
echo "--force-unlock: will override any existing active or dead locks on master and slave replica"
2013-11-03 19:29:17 +00:00
echo ""
echo "Quick usage:"
echo "--master= : Specify master replica path. Will contain state directory."
echo "--slave= : Spacift slave replica path. Will contain state directory."
2013-07-15 22:10:23 +00:00
exit 128
}
# Comand line argument flags
dryrun = 0
silent = 0
2013-07-21 19:40:55 +00:00
force_unlock = 0
2013-08-04 07:47:47 +00:00
no_maxtime = 0
2013-07-21 19:40:55 +00:00
if [ " $DEBUG " = = "yes" ]
then
verbose = 1
else
verbose = 0
fi
2013-07-15 22:10:23 +00:00
# Alert flags
soft_alert_total = 0
error_alert = 0
2013-07-16 21:06:26 +00:00
soft_stop = 0
2013-11-03 19:29:17 +00:00
quick_sync = 0
2013-07-15 22:10:23 +00:00
if [ $# -eq 0 ]
then
Usage
fi
for i in " $@ "
do
case $i in
--dry)
dryrun = 1
; ;
--silent)
silent = 1
; ;
2013-07-20 11:43:11 +00:00
--verbose)
verbose = 1
; ;
2013-07-21 19:40:55 +00:00
--force-unlock)
force_unlock = 1
; ;
2013-08-04 07:47:47 +00:00
--no-maxtime)
no_maxtime = 1
; ;
2013-07-20 11:43:11 +00:00
--help| -h| --version| -v)
2013-07-15 22:10:23 +00:00
Usage
; ;
2013-11-03 19:29:17 +00:00
--master= *)
quick_sync = $(( $quick_sync + 1 ))
no_maxtime = 1
MASTER_SYNC_DIR = ${ i ##*= }
; ;
--slave= *)
quick_sync = $(( $quick_sync + 1 ))
SLAVE_SYNC_DIR = ${ i ##*= }
no_maxtime = 1
; ;
2013-07-15 22:10:23 +00:00
esac
done
CheckEnvironment
if [ $? = = 0 ]
then
2013-11-03 19:29:17 +00:00
if [ $quick_sync -eq 2 ]
2013-06-18 11:34:14 +00:00
then
2013-11-03 19:29:17 +00:00
SYNC_ID = "quicksync task"
MINIMUM_SPACE = 1024
REMOTE_SYNC = no
CONFLICT_BACKUP_DAYS = 30
SOFT_DELETE_DAYS = 30
else
LoadConfigFile " $1 "
fi
Init
DATE = $( date)
Log "-------------------------------------------------------------"
Log " $DRY_WARNING $DATE - Osync v $OSYNC_VERSION script begin. "
Log "-------------------------------------------------------------"
Log " Sync task [ $SYNC_ID ] launched as $LOCAL_USER @ $LOCAL_HOST (PID $SCRIPT_PID ) "
GetOperatingSystem
if [ $no_maxtime -eq 1 ]
then
SOFT_MAX_EXEC_TIME = 0
HARD_MAX_EXEC_TIME = 0
fi
CheckMasterSlaveDirs
CheckMinimumSpace
if [ $? = = 0 ]
then
RunBeforeHook
Main
2013-07-15 22:10:23 +00:00
if [ $? = = 0 ]
then
2013-11-03 19:29:17 +00:00
SoftDelete
2013-06-18 11:34:14 +00:00
fi
2013-11-03 19:29:17 +00:00
RunAfterHook
2013-06-18 11:34:14 +00:00
fi
2013-07-15 22:10:23 +00:00
else
LogError "Environment not suitable to run osync."
2013-10-10 18:17:40 +00:00
exit 1
2013-07-15 22:10:23 +00:00
fi